<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
// local reference to another doc
<!ENTITY REDIM SYSTEM "references/reference.redim-protocol-01.xml">
<!ENTITY APC_WEB_GUIDELINES SYSTEM "references/reference.en-smm-apc-web-guidelines-01.xml">
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>


// categories: std | bcp | info | exp | historic
rfc(category='std' number='2417683' consensus='false' ipr='trust200902' docName='en-smm-web-guidelines-01' submissionType='be-cem-mro' xml:lang='en' version='3')
  front
    title(abbrev='EN-SMM WebDev guidelines') EN-SMM WebDev guidelines
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    date(year='2019' month="September")

    keyword WEB

    abstract
      t
        | This document describes EN-SMM group WebSite and Web Application
        | development guidelines.

  middle
    section
      name Introduction
      t
        | This document is a reference document for the EN-SMM group,
        | describing the WebSite and Web Application development recommendations
        | and requirements.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

    section
      name 2019 State of Art

      section
        name EN-SMM-MRO

        section
          name Back-end

          t MRO section uses IT provided DFS WebSites to host most of their WebSites.

          t
            | Back-ends are written in #[xref(target="PHP")],
            | #[xref(target="PYTHON_FLASK")] or using #[xref(target="CPP_RESTBED")].

        section
          name Front-end

          t Front-ends are implemented using the following technologies:
          ul
            li #[strong theming:] #[xref(target="BOOTSTRAP")]
            li #[strong engine:] #[xref(target="ANGULAR_1")]
            li #[strong charts:] #[xref(target="HIGHCHARTJS")]

        section
          name Projects

          t
            | Here is a non-exhaustive list of MRO projects that provide a Web
            | front-end.

          t
            strong #[xref(target="MRO_TIDVG4") TIDVG4]
          ul
            li #[tt back-end:] #[xref(target="PHP")]
            li #[tt front-end:] #[xref(target="ANGULAR_1")], #[xref(target="BOOTSTRAP")]
            li #[tt Note:] bad experience with Chart.js
            li #[tt Note:] back-end using a file generated by LabView from TN

          t
            strong #[xref(target="MRO_RPSE") RP Sample Exchanger]
          ul
            li #[tt back-end:] #[xref(target="PHP")] on DFS
            li #[tt front-end:] #[xref(target="ANGULAR_1")], #[xref(target="BOOTSTRAP")]
            li #[tt Note:] WebServer running on the same machine that controls the robot.
            li #[tt Note:] Current implementation is Lighttpd based, but should be replaced with CRF (CERN Robotics Framework).

          t
            strong #[xref(target="MRO_LHC_LK_DET") LHC Warm-Up Leak Detection]
          ul
            li #[tt back-end:] C++, Lighttpd on OpenStack
            li #[tt front-end:] MJPEG streams
            li #[tt Note:] External website displays only 1 image per second.

          t
            strong #[xref(target="MRO_ISO_MED_CAM") Isolde/Medicis Cameras]
          ul
            li #[tt back-end:] no back-end, direct MJPEG camera streams
            li #[tt front-end:] #[xref(target="ANGULAR_1")], #[xref(target="BOOTSTRAP")]

          t
            strong #[xref(target="MRO_TIM") TIM WebSite]
          ul
            li
              | #[tt back-end:] #[xref(target="CPP_RESTBED")] on OpenStack,
              | with a mix #[xref(target="PHP")] to access a CERN MySQL database and
              | #[xref(target="PYTHON_FLASK")] to access Timber through PyTimber.
            li #[tt front-end:] #[xref(target="ANGULAR_1")], #[xref(target="BOOTSTRAP")] and #[xref(target="HIGHCHARTJS")]

          t
            strong #[xref(target="MRO_RBNICS") Robotronics]
          ul
            li
              | #[tt back-end:] #[xref(target="PHP")] on DFS, with a connection
              | to a CERN MySQL database.
            li #[tt front-end:] #[xref(target="ANGULAR_1")], #[xref(target="BOOTSTRAP")]

      section
        name EN-SMM-MTA

        section
          name Back-end

          t
            | The MTA section has implemented and uses #[xref(target='MTA_RADE')],
            | a global network based proxy to CERN lower-level protocols,
            | and a LabView plugin that makes the CERN middleware accessible
            | to LabView users, this proxy being implemented in
            | Python and Java.

          t
            | MTA also develops and maintains some small
            | #[xref(target='PYTHON_FLASK') Python Flask] websites.

        section
          name Evolutions

          t
            | MTA plans to use #[xref(target="WEBVI") WebVI] from National
            | Instruments that can generate complete HTML5/JS WebSites from
            | LabView.

          t
            | LabView NXG is still under development and features such as
            | WebSockets over TLS will be available soon.

        section
          name Projects

          t
            | Here is a non-exhaustive list of MTA Web related projects.

          t
            strong #[xref(target="MTA_RADE_LOG") Rade Logs]
          ul
            li #[tt back-end:] ELK (Elastic-Search, Kibana, LogStash) on OpenStack
            li #[tt front-end:] Kibana

          t
            strong #[xref(target="MTA_LHC_DBOARD") LHC Dashboard]
          ul
            li #[tt back-end:] LabView by generating screenshots on DFS
            li #[tt front-end:] Small Javascript to auto-refresh the page
            li #[tt Note:] Aggregates RDA3, DIM, Experiment data and various files
            li #[tt Note:] History and caching using SQLite and Redis

          t
            strong #[xref(target='MTA_POSTMORTEM') Post Mortem Browser (prototype)]
          ul
            li #[tt back-end:] LabView process running in the background
            li #[tt front-end:] LabView generated WebVI page
            li #[tt Note:] Uses a REST API provided by TE-MPE-MS to access post-mortem data.

      section
        name EN-SMM-RME

        section
          name Back-end

          t
            | RME section uses IT provided OpenShift platform and some
            | OpenStack virtual-machines to host their Websites.

          t
            | Back-ends are written in #[xref(target="PYTHON_FLASK")].

        section
          name Front-end

          t Front-ends are implemented using the following technologies:
          ul
            li #[strong engine:] #[xref(target="JQUERY")]
            li #[strong theming:] #[xref(target="BOOTSTRAP") Bootstrap v3]

          t
            | #[strong Note:] JQuery is used by most of the higher level engines
            | (Vue.js, Angular.js ...), it is really low-level and not meant to
            | design big applications.

          t
            | #[strong Note:] Most of the websites are using an old version of
            | Bootstrap.

        section
          name Projects

          t
            | Here is a non-exhaustive list of RME projects that provide a Web
            | front-end.

          t
            strong #[xref(target="RME_CHARM") CHARM Facility Status]
          ul
            li #[tt back-end:] #[xref(target="PYTHON_FLASK")] on OpenStack using PyJAPC.
            li #[tt front-end:] #[xref(target="JQUERY") JQuery v1], #[xref(target="BOOTSTRAP") Bootstrap v3]

          t
            strong #[xref(target="RME_CO60") Co60 Facility Monitoring]
          ul
            li #[tt back-end:] #[xref(target="PYTHON_FLASK")] on OpenStack
            li #[tt front-end:] #[xref(target="JQUERY") JQuery v2], #[xref(target="BOOTSTRAP") Bootstrap v3]

          t
            strong #[xref(target="RME_RADWG") RadWG Test Database]
          ul
            li #[tt back-end:] #[xref(target="PYTHON_FLASK")] on OpenShift accessing a CERN MySQL DBOD
            li #[tt front-end:] #[xref(target="JQUERY") JQuery v2], #[xref(target="BOOTSTRAP") Bootstrap v3]

      section
        name EN-SMM-APC

        t
          | For a detailed introduction on EN-SMM-APC Web technologies and
          | guidelines, please refer to #[xref(target='en-smm-apc-web-guidelines-01')].

        section
          name Back-end

          t
            | Legacy websites are written in #[xref(target="PHP")] and hosted
            | on DFS.

          t
            | New websites are hosted on IT provided OpenShift platform, the
            | back-end is written either in #[xref(target="NODEJS")] or
            | C++ using #[xref(target="redim-protocol-01") ReDIM].

        section
          name Front-end

          t Front-ends are implemented using the following technologies:
          ul
            li #[strong theming:] #[xref(target="BOOTSTRAP")]
            li #[strong engine:] #[xref(target="VUEJS")]

        section
          name Projects

          t
            strong #[xref(target="APC_ALARMS") Piquet Service Alarms]
          ul
            li #[tt back-end:] #[xref(target="WSPP") WebSocket++] application on a physical machine (TN).
            li #[tt front-end:] #[xref(target="JQUERY") JQuery v1], #[xref(target="BOOTSTRAP") Bootstrap v3]

          t
            strong #[xref(target="APC_NTOFOLD") n_ToF legacy website]
          ul
            li #[tt back-end:] #[xref(target="PHP")] on CERN DFS share
            li #[tt front-end:] raw HTML

          t
            strong #[xref(target="APC_NTOFDAQ") n_ToF Standalone DAQ]
          ul
            li #[tt back-end:] #[xref(target="NODEJS") Node.js] on OpenShift container
            li #[tt front-end:] #[xref(target="VUEJS") Vue.js] and #[xref(target="BOOTSTRAP") Bootstrap v4]


    section
      name Guidelines

      section
        name Infrastructure
        t
          | WebSites back-end and front-end code #[bcp14 MUST] be versioned on
          | #[xref(target="CERN_GITLAB") CERN GitLab] repositories.

        t
          | It is #[bcp14 RECOMMENDED] to host WebSites and WebApplications on
          | #[xref(target="CERN_OPENSHIFT") IT provided OpenShift service],
          | this service being dedicated to that purpose and providing critical features such as:
        ul
          li TLS Certificates and secure connections
          li Built-in redundancy and load balancing
          li Health-checks and resources consumption analysis
          li Zero down-time deployments

        t
          | It is #[bcp14 RECOMMENDED] to build and deploy WebSites and WebApplications as
          | #[xref(target="DOCKER") Docker containers]
          | using #[xref(target="CERN_GITLAB") CERN GitLab-CI], for the reasons listed below:
        ul
          li Bundle a complete environment, including system libraries and dependencies
          li Ease deployment procedure and roll-out
          li Run unit and functional tests against production environment
          li Ability to run and debug production code on developer machine
          li Ability to cleanly deploy an heteroclite environment (ex: Python Back-end relying on Java services).

        t
          | Critical applications or servers #[bcp14 MAY] be hosted on
          | #[xref(target="CERN_OPENSTACK") CERN OpenStack]
          | (ex: to deploy on CERN Technical Network), special care and deployment
          | procedure #[bcp14 MUST] be documented and reproducible.

        t
          | Deploying docker containers on #[xref(target="CERN_OPENSTACK") CERN OpenStack]
          | #[bcp14 SHOULD] be evaluated (and is already documented), it #[bcp14 MAY] be
          | a technical solution to cleanly deploy applications on the CERN Technical Network.

        figure
          name Example Web-App deployment process
          artwork(align='center' type='binary-art' src='en-smm-apc-web-guidelines/web-app-deploy.png')

      section
        name Tests and Validation

        t
          | Both the front-end and back-end parts of each WebSite or WebApplication
          | #[bcp14 MUST] be tested and validated in a stubbed or mocked environment.

        t
          | Each library, module or component used in those applications
          | #[bcp14 MUST] also be independently tested.

        t
          | It is highly #[bcp14 RECOMMENDED] to automate the test and validation
          | of those applications.

        t
          | Code coverage #[bcp14 SHOULD] be above 80% for each, and it is
          |#[bcp14 RECOMMENDED] to keep it over 90%.

        t
          | Code styling #[bcp14 MUST] be enforced and validated for all languages
          | being used.

        t
          | It is #[bcp14 RECOMMENDED] to use Linting and TypeChecking (for untyped languages)
          | as much as possible.

      section
        name Back-end

        t
          | It is #[bcp14 RECOMMENDED] to use a scripting language such as
          | #[xref(target="NODEJS") Node.js] or #[xref(target="PYTHON_FLASK") Python]
          | to implement the WebSite or WebApplication itself.

        t
          | Machine-to-Machine or protocol gateways services #[bcp14 SHOULD] be implemented
          | in a more efficient language, C or C++ being #[bcp14 RECOMMENDED], but
          | depending on the service provider languages such as #[xref(target="JAVA_SPRING")] #[bcp14 MAY]
          | be used.

        t
          | It is #[bcp14 NOT RECOMMENDED] to use library bindings and add
          | unnecessary layers of transformation, vendor provided (and maintained)
          | libraries #[bcp14 SHOULD] always be preferred, relying on containerization
          | to aggregate various technologies.

        t
          | Since server-side rendering technologies such as #[xref(target="PHP")] tend
          | to produce really static WebSites and to not leverage code-reusability,
          | thus those technologies are #[bcp14 NOT RECOMMENDED].

      section
        name Front-end

        t
          | It is #[bcp14 RECOMMENDED] to use a combination of the major
          | frameworks listed below:
        ul
          li #[strong engine:] #[xref(target="VUEJS") Vue.js], #[xref(target="ANGULAR_2") Angular]
          li #[strong theming:] #[xref(target="BOOTSTRAP")]

        t
          | Front-end #[bcp14 SHOULD] be tested against stable versions of the
          | major browsers (Chrome, Firefox), it is #[bcp14 RECOMMENDED] to
          | also test with Edge and Safari.


      section
        name Middleware

        t
          | Today there are as many middlewares as sections in EN-SMM group
          | (MTA Rade, MRO Robotronics library, APC (Re)DIM) with as many gateways to
          | access other department services.

        t
          | Converging on those technologies and defining a communication media/protocol
          | that is independent from other services and flexible enough to be reused
          | by all sections is beyond the scope of this document be should but addressed.

    section
      name Contributors
      ul
        li Mario Di Castro (EN-SMM-MRO)
        li Giacomo Lunghi (EN-SMM-MRO)
        li Odd Oyvind Andreassen (EN-SMM-MTA)
        li Jospeh Tagg (EN-SMM-MTA)
        li Salvatore Danzeca (EN-SMM-RME)
        li Mathieu Donze (EN-SMM-APC)

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;
        | &REDIM;
        | &APC_WEB_GUIDELINES;

      references
        name URL References
        reference(anchor='PHP' target='https://www.php.net/')
          front
            title PHP is a popular general-purpose scripting language that is especially suited to web development.
            author
              organization The PHP Development Team, Zend Technologies
            date(year='1994')

        reference(anchor="PYTHON_FLASK" target='https://palletsprojects.com/p/flask/')
          front
            title Flask is a lightweight WSGI web application framework.
            author(fullname='Armin Ronacher' role='editor')
            date(year='2010')

        reference(anchor="JAVA_SPRING" target='https://spring.io')
          front
            title Spring: the source for modern java
            author
              organization Pivotal Software
          annotation #[tt License: Apache 2.0]

        reference(anchor="NODEJS" target='https://nodejs.org')
          front
            title Node.js is a JavaScript runtime built on Chrome's V8 JavaScript engine
            author(fullname='Ryan Dahl' role='editor')
            author
              organization Node.js Foundation
            date(year='2009')
          annotation #[tt License: MIT]

        reference(anchor="CPP_RESTBED" target='https://github.com/Corvusoft/restbed')
          front
            title Corvusoft's Restbed framework brings asynchronous RESTful functionality to C++11 applications.
            author
              organization Corvusfot
            date(year='2015')
          annotation #[tt License: Corvusoft or AFL]

        reference(anchor="WSPP" target='https://github.com/zaphoyd/websocketpp')
          front
            title WebSocket++ is a header only C++ library that implements RFC6455 The WebSocket Protocol.
            author(fullname='Peter Thorson' role='editor')
            date(year='2012')
          annotation #[tt License: AS-IS]

        reference(anchor='BOOTSTRAP' target='https://getbootstrap.com/')
          front
            title An open source toolkit for developing with HTML, CSS, and JS
            author(fullname='Mark Otto' role='editor')
            author(fullname='Jacob Thornton' role='editor')
            date(year='2011')
          annotation #[tt License: MIT]

        reference(anchor='JQUERY' target='https://jquery.com/')
          front
            title jQuery is a fast, small, and feature-rich JavaScript library.
            author(fullname='John Resig' role='editor')
            author
              organization jQuery Foundation
            date(year='2006')
          annotation #[tt License: MIT]

        reference(anchor='ANGULAR_1' target='https://angularjs.org/')
          front
            title AngularJS is a JavaScript-based open-source front-end web framework (V1.x)
            author
              organization Google
            date(year='2010')
          annotation #[tt License: MIT]

        reference(anchor='ANGULAR_2' target='https://angular.io/')
          front
            title One framework. Mobile &amp; desktop.
            author
              organization Google
            date(year='2016')
          annotation #[tt License: MIT]

        reference(anchor="VUEJS" target='https://vuejs.org/')
          front
            title The Progressive JavaScript Framework
            author(fullname='Evan You' role='editor')
            date(year='2014')
          annotation #[tt License: MIT]

        reference(anchor='HIGHCHARTJS' target='https://www.highcharts.com/products/highcharts')
          front
            title Highcharts makes it easy for developers to set up interactive charts in their web pages.
            author
              organization Highsoft
            date(year='2009')
          annotation #[tt License: Creative Commons (CC) Attribution-NonCommercial licence]

        reference(anchor='WEBVI' target='https://www.webvi.io')
          front
            title Remote UIs created in LabVIEW NXG
            author
              organization National Instruments
            date(year='2019')
          annotation #[tt License: National Instruments]

        reference(anchor='DOCKER' target='https://www.docker.com')
          front
            title Securely build, share and run modern applications anywhere
            author
              organization Docker Inc
            date(year='2013')
          annotation #[tt License: Apache 2.0]

      references
        name EN-SMM-MRO section projects

        reference(anchor="MRO_TIDVG4" target='https://robotronics.web.cern.ch/TIDVGMonitoring/')
          front
            title TIDVG4 Monitoring tool
            author #[organization EN-SMM-MRO]

        reference(anchor="MRO_RPSE" target='https://robotronics.web.cern.ch/rpsamplechanger/#!/')
          front
            title RP Sample Exchanger
            author #[organization EN-SMM-MRO]

        reference(anchor="MRO_LHC_LK_DET" target='http://heliumdetect-vm/#!/')
          front
            title LHC Warm-Up Leak Detection
            author #[organization EN-SMM-MRO]

        reference(anchor="MRO_ISO_MED_CAM" target='https://isomedcam.web.cern.ch/')
          front
            title Isolde/Medicis CAM
            author #[organization EN-SMM-MRO]

        reference(anchor="MRO_TIM" target='https://timlhc.web.cern.ch/')
          front
            title TIM WebSite
            author #[organization EN-SMM-MRO]

        reference(anchor="MRO_RBNICS" target='https://robotronics.web.cern.ch/')
          front
            title Robotronics document/video server
            author #[organization EN-SMM-MRO]

      references
        name EN-SMM-MTA section projects

        reference(anchor='MTA_RADE' target='https://cern.ch/rade')
          front
            title Rapid Application Development Environment based on LabVIEW
            author #[organization EN-SMM-MTA]

        reference(anchor='MTA_RADE_LOG' target='https://cern.ch/rade-logger')
          front
            title Rade Logger
            author #[organization EN-SMM-MTA]

        reference(anchor='MTA_LHC_DBOARD' target='https://op-webtools.web.cern.ch/Vistar/vistars.php?usr=LHCDASHBOARD')
          front
            title LHC Dashboard
            author #[organization EN-SMM-MTA]

        reference(anchor='MTA_POSTMORTEM' target='https://radedev.web.cern.ch/radedev/pmb-light/Main.html')
          front
            title Post-Mortem browser
            author #[organization EN-SMM-MTA]

      references
        name EN-SMM-RME section projects

        reference(anchor='RME_CHARM' target='http://charm.web.cern.ch/content/monitoring')
          front
            title Charm Facility Status
            author #[organization EN-SMM-RME]

        reference(anchor='RME_CO60' target='https://cc60facility.web.cern.ch/monitoring')
          front
            title Co60 Facility Monitoring
            author #[organization EN-SMM-RME]

        reference(anchor='RME_RADWG' target='https://radwg.web.cern.ch/content/radiation-test-database')
          front
            title Radiation Working Group Test Database
            author #[organization EN-SMM-RME]

      references
        name EN-SMM-APC section projects

        reference(anchor='APC_ALARMS' target='http://ab-atb-lpe.web.cern.ch/ab-atb-lpe/piquet/2.0/')
          front
            title Piquet Service Alarms
            author #[organization EN-SMM-APC]

        reference(anchor='APC_NTOFOLD' target='https://project-ntof.web.cern.ch/project-ntof/')
          front
            title n_ToF legacy website
            author #[organization EN-SMM-APC]

        reference(anchor='APC_NTOFDAQ' target='https://ntof-daq.web.cern.ch/standalone')
          front
            title n_ToF Standalone DAQ
            author #[organization EN-SMM-APC]

      references
        name CERN services

        reference(anchor='CERN_OPENSHIFT' target='https://openshift.cern.ch')
          front
            title CERN OpenShift service
            author #[organization IT-CDA]

        reference(anchor='CERN_GITLAB' target='https://gitlab.cern.ch')
          front
            title CERN GitLab service
            author #[organization IT-CDA]

        reference(anchor='CERN_OPENSTACK' target='https://openstack.cern.ch')
          front
            title CERN OpenStack service
            author #[organization IT-CM]

    section
      name Change Log

    section
      name Open Issues
